Index: drivers/filesystems/btrfs/write.c
===================================================================
--- drivers/filesystems/btrfs/write.c	(révision 75772)
+++ drivers/filesystems/btrfs/write.c	(copie de travail)
@@ -2344,144 +2566,115 @@
                                 }
                             }
                         }
-                        
-                        neda = ExAllocatePoolWithTag(PagedPool, sizeof(EXTENT_DATA) - 1 + sizeof(EXTENT_DATA2), ALLOC_TAG);
-                        if (!neda) {
-                            ERR("out of memory\n");
-                            Status = STATUS_INSUFFICIENT_RESOURCES;
-                            goto end;
-                        }
-                        
-                        newext1 = ExAllocatePoolWithTag(PagedPool, sizeof(extent), ALLOC_TAG);
+
+                        newext1 = ExAllocatePoolWithTag(PagedPool, offsetof(extent, extent_data) + sizeof(EXTENT_DATA) - 1 + sizeof(EXTENT_DATA2), ALLOC_TAG);
                         if (!newext1) {
                             ERR("out of memory\n");
                             Status = STATUS_INSUFFICIENT_RESOURCES;
-                            ExFreePool(neda);
                             goto end;
                         }
-                        
-                        nedb = ExAllocatePoolWithTag(PagedPool, sizeof(EXTENT_DATA) - 1 + sizeof(EXTENT_DATA2), ALLOC_TAG);
-                        if (!nedb) {
-                            ERR("out of memory\n");
-                            Status = STATUS_INSUFFICIENT_RESOURCES;
-                            ExFreePool(neda);
-                            ExFreePool(newext1);
-                            goto end;
-                        }
-                        
-                        newext2 = ExAllocatePoolWithTag(PagedPool, sizeof(extent), ALLOC_TAG);
+
+                        newext2 = ExAllocatePoolWithTag(PagedPool, offsetof(extent, extent_data) + sizeof(EXTENT_DATA) - 1 + sizeof(EXTENT_DATA2), ALLOC_TAG);
                         if (!newext2) {
                             ERR("out of memory\n");
                             Status = STATUS_INSUFFICIENT_RESOURCES;
-                            ExFreePool(neda);
                             ExFreePool(newext1);
-                            ExFreePool(nedb);
                             goto end;
                         }
-                        
-                        neda2 = (EXTENT_DATA2*)&neda->data[0];
-                        
-                        neda->generation = Vcb->superblock.generation;
-                        neda->decoded_size = ed->decoded_size;
-                        neda->compression = ed->compression;
-                        neda->encryption = ed->encryption;
-                        neda->encoding = ed->encoding;
-                        neda->type = ed->type;
+
+                        neda2 = (EXTENT_DATA2*)newext1->extent_data.data;
+
+                        newext1->extent_data.generation = Vcb->superblock.generation;
+                        newext1->extent_data.decoded_size = ed->decoded_size;
+                        newext1->extent_data.compression = ed->compression;
+                        newext1->extent_data.encryption = ed->encryption;
+                        newext1->extent_data.encoding = ed->encoding;
+                        newext1->extent_data.type = ed->type;
                         neda2->address = ed2->address;
                         neda2->size = ed2->size;
                         neda2->offset = ed2->offset;
                         neda2->num_bytes = start_data - ext->offset;
 
-                        nedb2 = (EXTENT_DATA2*)&nedb->data[0];
-                        
-                        nedb->generation = Vcb->superblock.generation;
-                        nedb->decoded_size = ed->decoded_size;
-                        nedb->compression = ed->compression;
-                        nedb->encryption = ed->encryption;
-                        nedb->encoding = ed->encoding;
-                        nedb->type = ed->type;
+                        nedb2 = (EXTENT_DATA2*)newext2->extent_data.data;
+
+                        newext2->extent_data.generation = Vcb->superblock.generation;
+                        newext2->extent_data.decoded_size = ed->decoded_size;
+                        newext2->extent_data.compression = ed->compression;
+                        newext2->extent_data.encryption = ed->encryption;
+                        newext2->extent_data.encoding = ed->encoding;
+                        newext2->extent_data.type = ed->type;
                         nedb2->address = ed2->address;
                         nedb2->size = ed2->size;
                         nedb2->offset = ed2->offset + (end_data - ext->offset);
                         nedb2->num_bytes = ext->offset + len - end_data;
-                        
+
                         newext1->offset = ext->offset;
-                        newext1->data = neda;
                         newext1->datalen = sizeof(EXTENT_DATA) - 1 + sizeof(EXTENT_DATA2);
                         newext1->unique = ext->unique;
                         newext1->ignore = FALSE;
                         newext1->inserted = TRUE;
-                        
+
                         newext2->offset = end_data;
-                        newext2->data = nedb;
                         newext2->datalen = sizeof(EXTENT_DATA) - 1 + sizeof(EXTENT_DATA2);
                         newext2->unique = ext->unique;
                         newext2->ignore = FALSE;
                         newext2->inserted = TRUE;
-                        
+
                         if (ext->csum) {
                             if (ed->compression == BTRFS_COMPRESSION_NONE) {
-                                newext1->csum = ExAllocatePoolWithTag(PagedPool, neda2->num_bytes * sizeof(UINT32) / Vcb->superblock.sector_size, ALLOC_TAG);
+                                newext1->csum = ExAllocatePoolWithTag(PagedPool, (ULONG)(neda2->num_bytes * sizeof(UINT32) / Vcb->superblock.sector_size), ALLOC_TAG);
                                 if (!newext1->csum) {
                                     ERR("out of memory\n");
                                     Status = STATUS_INSUFFICIENT_RESOURCES;
-                                    ExFreePool(neda);
                                     ExFreePool(newext1);
-                                    ExFreePool(nedb);
                                     ExFreePool(newext2);
                                     goto end;
                                 }
-                                
-                                newext2->csum = ExAllocatePoolWithTag(PagedPool, nedb2->num_bytes * sizeof(UINT32) / Vcb->superblock.sector_size, ALLOC_TAG);
+
+                                newext2->csum = ExAllocatePoolWithTag(PagedPool, (ULONG)(nedb2->num_bytes * sizeof(UINT32) / Vcb->superblock.sector_size), ALLOC_TAG);
                                 if (!newext2->csum) {
                                     ERR("out of memory\n");
                                     Status = STATUS_INSUFFICIENT_RESOURCES;
                                     ExFreePool(newext1->csum);
-                                    ExFreePool(neda);
                                     ExFreePool(newext1);
-                                    ExFreePool(nedb);
                                     ExFreePool(newext2);
                                     goto end;
                                 }
-                                
-                                RtlCopyMemory(newext1->csum, ext->csum, neda2->num_bytes * sizeof(UINT32) / Vcb->superblock.sector_size);
+
+                                RtlCopyMemory(newext1->csum, ext->csum, (ULONG)(neda2->num_bytes * sizeof(UINT32) / Vcb->superblock.sector_size));
                                 RtlCopyMemory(newext2->csum, &ext->csum[(end_data - ext->offset) / Vcb->superblock.sector_size],
-                                              nedb2->num_bytes * sizeof(UINT32) / Vcb->superblock.sector_size);
+                                              (ULONG)(nedb2->num_bytes * sizeof(UINT32) / Vcb->superblock.sector_size));
                             } else {
-                                newext1->csum = ExAllocatePoolWithTag(PagedPool, ed2->size * sizeof(UINT32) / Vcb->superblock.sector_size, ALLOC_TAG);
+                                newext1->csum = ExAllocatePoolWithTag(PagedPool, (ULONG)(ed2->size * sizeof(UINT32) / Vcb->superblock.sector_size), ALLOC_TAG);
                                 if (!newext1->csum) {
                                     ERR("out of memory\n");
                                     Status = STATUS_INSUFFICIENT_RESOURCES;
-                                    ExFreePool(neda);
                                     ExFreePool(newext1);
-                                    ExFreePool(nedb);
                                     ExFreePool(newext2);
                                     goto end;
                                 }
-                                
-                                newext2->csum = ExAllocatePoolWithTag(PagedPool, ed2->size * sizeof(UINT32) / Vcb->superblock.sector_size, ALLOC_TAG);
-                                if (!newext1->csum) {
+
+                                newext2->csum = ExAllocatePoolWithTag(PagedPool, (ULONG)(ed2->size * sizeof(UINT32) / Vcb->superblock.sector_size), ALLOC_TAG);
+                                if (!newext2->csum) {
                                     ERR("out of memory\n");
                                     Status = STATUS_INSUFFICIENT_RESOURCES;
                                     ExFreePool(newext1->csum);
-                                    ExFreePool(neda);
                                     ExFreePool(newext1);
-                                    ExFreePool(nedb);
                                     ExFreePool(newext2);
                                     goto end;
                                 }
-                                
-                                RtlCopyMemory(newext1->csum, ext->csum, ed2->size * sizeof(UINT32) / Vcb->superblock.sector_size);
-                                RtlCopyMemory(newext2->csum, ext->csum, ed2->size * sizeof(UINT32) / Vcb->superblock.sector_size);
+
+                                RtlCopyMemory(newext1->csum, ext->csum, (ULONG)(ed2->size * sizeof(UINT32) / Vcb->superblock.sector_size));
+                                RtlCopyMemory(newext2->csum, ext->csum, (ULONG)(ed2->size * sizeof(UINT32) / Vcb->superblock.sector_size));
                             }
                         } else {
                             newext1->csum = NULL;
                             newext2->csum = NULL;
                         }
-                        
+
                         InsertHeadList(&ext->list_entry, &newext1->list_entry);
-                        InsertHeadList(&newext1->list_entry, &newext2->list_entry);
-                        
+                        add_extent(fcb, &newext1->list_entry, newext2);
+
                         remove_fcb_extent(fcb, ext, rollback);
                     }
                 }
@@ -2490,113 +2683,121 @@
 
         le = le2;
     }
-    
+
     Status = STATUS_SUCCESS;
 
 end:
     fcb->extents_changed = TRUE;
     mark_fcb_dirty(fcb);
-    
+
     return Status;
 }
 
-static void add_insert_extent_rollback(LIST_ENTRY* rollback, fcb* fcb, extent* ext) {
+void add_insert_extent_rollback(LIST_ENTRY* rollback, fcb* fcb, extent* ext) {
     rollback_extent* re;
-    
+
     re = ExAllocatePoolWithTag(NonPagedPool, sizeof(rollback_extent), ALLOC_TAG);
     if (!re) {
         ERR("out of memory\n");
         return;
     }
-    
+
     re->fcb = fcb;
     re->ext = ext;
-    
-    add_rollback(fcb->Vcb, rollback, ROLLBACK_INSERT_EXTENT, re);
+
+    add_rollback(rollback, ROLLBACK_INSERT_EXTENT, re);
 }
 
-static BOOL add_extent_to_fcb(fcb* fcb, UINT64 offset, EXTENT_DATA* ed, ULONG edsize, BOOL unique, UINT32* csum, LIST_ENTRY* rollback) {
+#ifdef _MSC_VER
+#pragma warning(push)
+#pragma warning(suppress: 28194)
+#endif
+NTSTATUS add_extent_to_fcb(_In_ fcb* fcb, _In_ UINT64 offset, _In_reads_bytes_(edsize) EXTENT_DATA* ed, _In_ UINT16 edsize,
+                           _In_ BOOL unique, _In_opt_ _When_(return >= 0, __drv_aliasesMem) UINT32* csum, _In_ LIST_ENTRY* rollback) {
     extent* ext;
     LIST_ENTRY* le;
-    
-    ext = ExAllocatePoolWithTag(PagedPool, sizeof(extent), ALLOC_TAG);
+
+    ext = ExAllocatePoolWithTag(PagedPool, offsetof(extent, extent_data) + edsize, ALLOC_TAG);
     if (!ext) {
         ERR("out of memory\n");
-        return FALSE;
+        return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
+
     ext->offset = offset;
-    ext->data = ed;
     ext->datalen = edsize;
     ext->unique = unique;
     ext->ignore = FALSE;
     ext->inserted = TRUE;
     ext->csum = csum;
-    
+
+    RtlCopyMemory(&ext->extent_data, ed, edsize);
+
     le = fcb->extents.Flink;
     while (le != &fcb->extents) {
         extent* oldext = CONTAINING_RECORD(le, extent, list_entry);
-        
-        if (!oldext->ignore) {
-            if (oldext->offset > offset) {
-                InsertHeadList(le->Blink, &ext->list_entry);
-                goto end;
-            }
+
+        if (oldext->offset >= offset) {
+            InsertHeadList(le->Blink, &ext->list_entry);
+            goto end;
         }
-        
+
         le = le->Flink;
     }
-    
+
     InsertTailList(&fcb->extents, &ext->list_entry);
-    
+
 end:
     add_insert_extent_rollback(rollback, fcb, ext);
 
-    return TRUE;
+    return STATUS_SUCCESS;
 }
+#ifdef _MSC_VER
+#pragma warning(pop)
+#endif
 
 static void remove_fcb_extent(fcb* fcb, extent* ext, LIST_ENTRY* rollback) {
     if (!ext->ignore) {
         rollback_extent* re;
-        
+
         ext->ignore = TRUE;
-        
+
         re = ExAllocatePoolWithTag(NonPagedPool, sizeof(rollback_extent), ALLOC_TAG);
         if (!re) {
             ERR("out of memory\n");
             return;
         }
-        
+
         re->fcb = fcb;
         re->ext = ext;
-        
-        add_rollback(fcb->Vcb, rollback, ROLLBACK_DELETE_EXTENT, re);
+
+        add_rollback(rollback, ROLLBACK_DELETE_EXTENT, re);
     }
 }
 
-static NTSTATUS calc_csum(device_extension* Vcb, UINT8* data, UINT32 sectors, UINT32* csum) {
+NTSTATUS calc_csum(_In_ device_extension* Vcb, _In_reads_bytes_(sectors*Vcb->superblock.sector_size) UINT8* data,
+                   _In_ UINT32 sectors, _Out_writes_bytes_(sectors*sizeof(UINT32)) UINT32* csum) {
     NTSTATUS Status;
     calc_job* cj;
-    
+
     // From experimenting, it seems that 40 sectors is roughly the crossover
     // point where offloading the crc32 calculation becomes worth it.
-    
-    if (sectors < 40) {
+
+    if (sectors < 40 || KeQueryActiveProcessorCount(NULL) < 2) {
         ULONG j;
-        
+
         for (j = 0; j < sectors; j++) {
             csum[j] = ~calc_crc32c(0xffffffff, data + (j * Vcb->superblock.sector_size), Vcb->superblock.sector_size);
         }
-        
+
         return STATUS_SUCCESS;
     }
-    
+
     Status = add_calc_job(Vcb, data, sectors, csum, &cj);
     if (!NT_SUCCESS(Status)) {
         ERR("add_calc_job returned %08x\n", Status);
         return Status;
     }
-    
+
     KeWaitForSingleObject(&cj->event, Executive, KernelMode, FALSE, NULL);
     free_calc_job(cj);
 
@@ -2603,38 +2804,22 @@
     return STATUS_SUCCESS;
 }
 
-BOOL insert_extent_chunk(device_extension* Vcb, fcb* fcb, chunk* c, UINT64 start_data, UINT64 length, BOOL prealloc, void* data,
-                         PIRP Irp, LIST_ENTRY* rollback, UINT8 compression, UINT64 decoded_size) {
+_Requires_lock_held_(c->lock)
+_When_(return != 0, _Releases_lock_(c->lock))
+BOOL insert_extent_chunk(_In_ device_extension* Vcb, _In_ fcb* fcb, _In_ chunk* c, _In_ UINT64 start_data, _In_ UINT64 length, _In_ BOOL prealloc, _In_opt_ void* data,
+                         _In_opt_ PIRP Irp, _In_ LIST_ENTRY* rollback, _In_ UINT8 compression, _In_ UINT64 decoded_size, _In_ BOOL file_write, _In_ UINT64 irp_offset) {
     UINT64 address;
     NTSTATUS Status;
     EXTENT_DATA* ed;
     EXTENT_DATA2* ed2;
-    ULONG edsize = sizeof(EXTENT_DATA) - 1 + sizeof(EXTENT_DATA2);
+    UINT16 edsize = (UINT16)(offsetof(EXTENT_DATA, data[0]) + sizeof(EXTENT_DATA2));
     UINT32* csum = NULL;
-// #ifdef DEBUG_PARANOID
-//     traverse_ptr tp;
-//     KEY searchkey;
-// #endif
-    
+
     TRACE("(%p, (%llx, %llx), %llx, %llx, %llx, %u, %p, %p)\n", Vcb, fcb->subvol->id, fcb->inode, c->offset, start_data, length, prealloc, data, rollback);
-    
+
     if (!find_data_address_in_chunk(Vcb, c, length, &address))
         return FALSE;
-    
-// #ifdef DEBUG_PARANOID
-//     searchkey.obj_id = address;
-//     searchkey.obj_type = TYPE_EXTENT_ITEM;
-//     searchkey.offset = 0xffffffffffffffff;
-//     
-//     Status = find_item(Vcb, Vcb->extent_root, &tp, &searchkey, FALSE);
-//     if (!NT_SUCCESS(Status)) {
-//         ERR("error - find_item returned %08x\n", Status);
-//     } else if (tp.item->key.obj_id == searchkey.obj_id && tp.item->key.obj_type == searchkey.obj_type) {
-//         ERR("address %llx already allocated\n", address);
-//         int3;
-//     }
-// #endif
-    
+
     // add extent data to inode
     ed = ExAllocatePoolWithTag(PagedPool, edsize, ALLOC_TAG);
     if (!ed) {
@@ -2641,7 +2826,7 @@
         ERR("out of memory\n");
         return FALSE;
     }
-    
+
     ed->generation = Vcb->superblock.generation;
     ed->decoded_size = decoded_size;
     ed->compression = compression;
@@ -2648,54 +2833,62 @@
     ed->encryption = BTRFS_ENCRYPTION_NONE;
     ed->encoding = BTRFS_ENCODING_NONE;
     ed->type = prealloc ? EXTENT_TYPE_PREALLOC : EXTENT_TYPE_REGULAR;
-    
+
     ed2 = (EXTENT_DATA2*)ed->data;
     ed2->address = address;
     ed2->size = length;
     ed2->offset = 0;
     ed2->num_bytes = decoded_size;
-    
+
     if (!prealloc && data && !(fcb->inode_item.flags & BTRFS_INODE_NODATASUM)) {
-        ULONG sl = length / Vcb->superblock.sector_size;
-        
+        ULONG sl = (ULONG)(length / Vcb->superblock.sector_size);
+
         csum = ExAllocatePoolWithTag(PagedPool, sl * sizeof(UINT32), ALLOC_TAG);
         if (!csum) {
             ERR("out of memory\n");
+            ExFreePool(ed);
             return FALSE;
         }
-        
+
         Status = calc_csum(Vcb, data, sl, csum);
         if (!NT_SUCCESS(Status)) {
             ERR("calc_csum returned %08x\n", Status);
+            ExFreePool(csum);
+            ExFreePool(ed);
             return FALSE;
         }
     }
-    
-    if (!add_extent_to_fcb(fcb, start_data, ed, edsize, TRUE, csum, rollback)) {
-        ERR("add_extent_to_fcb failed\n");
+
+    Status = add_extent_to_fcb(fcb, start_data, ed, edsize, TRUE, csum, rollback);
+    if (!NT_SUCCESS(Status)) {
+        ERR("add_extent_to_fcb returned %08x\n", Status);
+        if (csum) ExFreePool(csum);
         ExFreePool(ed);
         return FALSE;
     }
-    
-    increase_chunk_usage(c, length);
-    space_list_subtract(Vcb, c, FALSE, address, length, rollback);
-    
+
+    ExFreePool(ed);
+
+    c->used += length;
+    space_list_subtract(c, FALSE, address, length, rollback);
+
     fcb->inode_item.st_blocks += decoded_size;
-    
+
     fcb->extents_changed = TRUE;
     fcb->inode_item_changed = TRUE;
     mark_fcb_dirty(fcb);
-    
+
     ExAcquireResourceExclusiveLite(&c->changed_extents_lock, TRUE);
-    
+
     add_changed_extent_ref(c, address, length, fcb->subvol->id, fcb->inode, start_data, 1, fcb->inode_item.flags & BTRFS_INODE_NODATASUM);
-    
+
     ExReleaseResourceLite(&c->changed_extents_lock);
-    
+
     ExReleaseResourceLite(&c->lock);
-      
+
     if (data) {
-        Status = write_data_complete(Vcb, address, data, length, Irp, NULL);
+        Status = write_data_complete(Vcb, address, data, (UINT32)length, Irp, NULL, file_write, irp_offset,
+                                     fcb->Header.Flags2 & FSRTL_FLAG2_IS_PAGING_FILE ? HighPagePriority : NormalPagePriority);
         if (!NT_SUCCESS(Status))
             ERR("write_data_complete returned %08x\n", Status);
     }
@@ -2704,20 +2897,19 @@
 }
 
 static BOOL try_extend_data(device_extension* Vcb, fcb* fcb, UINT64 start_data, UINT64 length, void* data,
-                            PIRP Irp, UINT64* written, LIST_ENTRY* rollback) {
+                            PIRP Irp, UINT64* written, BOOL file_write, UINT64 irp_offset, LIST_ENTRY* rollback) {
     BOOL success = FALSE;
     EXTENT_DATA* ed;
     EXTENT_DATA2* ed2;
     chunk* c;
     LIST_ENTRY* le;
-    space* s;
     extent* ext = NULL;
-    
+
     le = fcb->extents.Flink;
-    
+
     while (le != &fcb->extents) {
         extent* nextext = CONTAINING_RECORD(le, extent, list_entry);
-        
+
         if (!nextext->ignore) {
             if (nextext->offset == start_data) {
                 ext = nextext;
